<?php
if(!defined('VALID_CMS_ADMIN')) { die('ACCESS DENIED'); }
/*******************************************************************************/
//                          InstantCMS v1.9                                    //
//                      http://www.instantcms.ru/                              //
//                         component "SEO_PAGE" v1.0                           //
//                     written by Marat Fatikhov  aka                     //
//                     http://www.instantcms.ru/users/marat                    //
//                       E-mail: f-marat@mail.ru                               //
//                                                                             //
//                      LICENSED BY GNU/GPL v2                                 //
//                                                                             //
/********************************************************************************/
$inDB = cmsDatabase::getInstance();
define('REW_FILE', PATH.'/custom_rewrite.php');
define('SITE_NAME', 'http://'.$_SERVER['SERVER_NAME'].'/');

function activatePageRoute($id){
     $content = '';
     $content = file_get_contents(REW_FILE);
     $pattern = '/\\/\\*\\/\\/start_seo_page-'.$id.'(.*?)\\/\\/end_seo_page-'.$id.'\\*\\//is';
     // - 
     $replacement = '//start_seo_page-'.$id.'$1//end_seo_page-'.$id;
     $content = preg_replace($pattern, $replacement, $content);
     $bits = file_put_contents(REW_FILE, $content);
     
     return true;
}

function deActivatePageRoute($id){
     $content = '';
     $content = file_get_contents(REW_FILE);
     $pattern = '/\\/\\/start_seo_page-'.$id.'(\\s)(.*?)\\/\\/end_seo_page-'.$id.'(\\s)/is';
     // - 
     $replacement = '/*//start_seo_page-'.$id.'$1$2//end_seo_page-'.$id.'*/$3';
     $content = preg_replace($pattern, $replacement, $content);
     $bits = file_put_contents(REW_FILE, $content);

     return true;
}

cpAddPathway('SEO ', '?view=components&do=config&id='.(int)$_REQUEST['id']);
echo '<h3>SEO </h3>';
if (isset($_REQUEST['opt'])) { $opt = $_REQUEST['opt']; } else { $opt = 'list_items'; }

$toolmenu = array();

$toolmenu[0]['icon'] = 'newstuff.gif';
$toolmenu[0]['title'] = ' SEO-';
$toolmenu[0]['link'] = '?view=components&do=config&id='.(int)$_REQUEST['id'].'&opt=add_item';

$toolmenu[1]['icon'] = 'liststuff.gif';
$toolmenu[1]['title'] = ' SEO-';
$toolmenu[1]['link'] = '?view=components&do=config&id='.(int)$_REQUEST['id'].'&opt=list_items';

if($opt == 'list_items' || $opt == 'show_item' || $opt == 'hide_item'){
   $toolmenu[2]['icon'] = 'edit.gif';
   $toolmenu[2]['title'] = ' ';
   $toolmenu[2]['link'] = "javascript:checkSel('?view=components&do=config&id=".(int)$_REQUEST['id']."&opt=edit_item&multiple=1');";

   $toolmenu[3]['icon'] = 'show.gif';
   $toolmenu[3]['title'] = ' ';
   $toolmenu[3]['link'] = "javascript:checkSel('?view=components&do=config&id=".(int)$_REQUEST['id']."&opt=show_item&multiple=1');";

   $toolmenu[4]['icon'] = 'hide.gif';
   $toolmenu[4]['title'] = ' ';
   $toolmenu[4]['link'] = "javascript:checkSel('?view=components&do=config&id=".(int)$_REQUEST['id']."&opt=hide_item&multiple=1');";

   $toolmenu[5]['icon'] = 'delete.gif';
   $toolmenu[5]['title'] = ' ';
   $toolmenu[5]['link'] = "javascript:checkSel('?view=components&do=config&id=".(int)$_REQUEST['id']."&opt=delete_item&multiple=1');";
}

if($opt != 'list_items'){
		$toolmenu[17]['icon'] = 'cancel.gif';
		$toolmenu[17]['title'] = '';
		$toolmenu[17]['link'] = '?view=components&do=config&id='.(int)$_REQUEST['id'].'&opt=list_items';
}

cpToolMenu($toolmenu);

$inCore->loadModel('seo_page');
$model = new cms_model_seo_page();

if ($opt == 'submit_item'){

    $error = false;

    // 
    $request_uri = trim($inCore->request('request_uri', 'str', ''));
    $target_uri = trim($inCore->request('target_uri', 'str', ''));
    $note = $inCore->request('note', 'str', '');
    $page_title = $inCore->request('page_title', 'str', '');
    $meta_desc = $inCore->request('meta_desc', 'str', '');
    $meta_keys = $inCore->request('meta_keys', 'str', '');
    
    if(!$request_uri){ cmsCore::addSessionMessage( '      " URI".  .', 'error'); $error = true; }
    //    
    $request_uri = trim($request_uri, '/');
    $target_uri = ltrim($target_uri, '/');
    $prefix = 'http://';
    $site_name = $_SERVER['SERVER_NAME'].'/';
    $request_uri = str_replace($prefix, '', $request_uri);
    $request_uri = str_replace($site_name, '', $request_uri);
    //,     
        $first_slash_pos = strpos($request_uri, '/');
    if ($first_slash_pos){
            //  ,       
            $component  = substr($request_uri, 0, $first_slash_pos);
    } else {
            //  ,     
            $component  = $request_uri;
    }
    if (!is_dir(PATH.'/components/'.$component)){
            //   ,    content
            $component = 'content';
    }
    
    $sql = "INSERT INTO `cms_seo_page` (note, component, request_uri, target_uri, page_title, meta_desc, meta_keys, published)
            VALUES ('$note', '$component', '$request_uri', '$target_uri', '$page_title', '$meta_desc', '$meta_keys', 1)";

    if(!$error){ $inDB->query($sql) ;}
    $last_id = $inDB->get_last_id('cms_seo_page');
    if(!$last_id && !$error){cmsCore::addSessionMessage('     .', 'error'); $error = true;}
    if($target_uri && !$error){
       // 
       $rules = '
                 //start_seo_page-'.$last_id.'
                 $rules[] = array(
                            \'source\'  => \'/^'.str_replace('/', '\/', $request_uri).'$/i\',
                            \'target\'  => \''.SITE_NAME.$target_uri.'\',
                            \'action\'  => \'redirect-301\'
                         );

                 $rules[] = array(
                            \'source\'  => \'/^'.str_replace('/', '\/', $target_uri).'$/i\',
                            \'target\'  => \''.$request_uri.'\',
                            \'action\'  => \'rewrite\'
                         );
                 //end_seo_page-'.$last_id;
       //    custom_rewrite
       $content = '';
       $content = file_get_contents(REW_FILE);
       if(!$content){ cmsCore::addSessionMessage('      /custom_rewrite.php.       .', 'error'); $error = true; }
       if(!$error){
          $pattern =  '/(.*?)function custom_rewrite_rules\\(\\){(.*?)/is';
          $replacement = '$1function custom_rewrite_rules(){'.$rules.'$2';
          $content = preg_replace($pattern, $replacement, $content);
          $bits = file_put_contents(REW_FILE, $content);
          if($bits == 0){ cmsCore::addSessionMessage('      /custom_rewrite.php.       .', 'error'); $error = true;}
       }
    }
    if($error){$inCore->redirect('?view=components&do=config&opt=add_item&id='.(int)$_REQUEST['id']);}

    header('location:?view=components&do=config&opt=list_items&id='.(int)$_REQUEST['id']);
}

if ($opt == 'update_item'){

    $error = false;

    if(isset($_REQUEST['item_id'])) {
        // 
        $item_id =  $inCore->request('item_id', 'int', 0);
        $request_uri = trim($inCore->request('request_uri', 'str', ''));
        $target_uri = trim($inCore->request('target_uri', 'str', ''));
        $note = $inCore->request('note', 'str', '');
        $page_title = $inCore->request('page_title', 'str', '');
        $meta_desc = $inCore->request('meta_desc', 'str', '');
        $meta_keys = $inCore->request('meta_keys', 'str', '');
        
        //    
        $old = array();
        $old = $model->getSeoPage($item_id);
        if(!$old){ header('location:?view=components&do=config&opt=list_items&id='.(int)$_REQUEST['id']); }
        if(!$request_uri){ $request_uri = $old['request_uri']; }
        //    
        $request_uri = trim($request_uri, '/');
        $target_uri = ltrim($target_uri, '/');
        $prefix = 'http://';
        $site_name = $_SERVER['SERVER_NAME'].'/';
        $request_uri = str_replace($prefix, '', $request_uri);
        $request_uri = str_replace($site_name, '', $request_uri);
        //,     
        $first_slash_pos = strpos($request_uri, '/');
        if ($first_slash_pos){
           //  ,       
            $component  = substr($request_uri, 0, $first_slash_pos);
        } else {
            //  ,     
            $component  = $request_uri;
        }
        if (!is_dir(PATH.'/components/'.$component)){
            //   ,    content
            $component = 'content';
        }

        $content = '';
        $content = file_get_contents(REW_FILE);
        if(!$content){ cmsCore::addSessionMessage('      /custom_rewrite.php.       .', 'error'); $error = true; }
        // 
       $rules = '
                 //start_seo_page-'.$item_id.'
                 $rules[] = array(
                            \'source\'  => \'/^'.str_replace('/', '\/', $request_uri).'$/i\',
                            \'target\'  => \''.SITE_NAME.$target_uri.'\',
                            \'action\'  => \'redirect-301\'
                         );

                 $rules[] = array(
                            \'source\'  => \'/^'.str_replace('/', '\/', $target_uri).'$/i\',
                            \'target\'  => \''.$request_uri.'\',
                            \'action\'  => \'rewrite\'
                         );
                 //end_seo_page-'.$item_id;
        //     ,     custom_rewrite.php
        if(!$target_uri){
            if($old['target_uri']){
                //
                $pattern = '/\\/\\/start_seo_page-'.$item_id.'(.*?)\\/\\/end_seo_page-'.$item_id.'/is';
                $content = preg_replace($pattern, '', $content);
                //  ,   
                $content = preg_replace('/\\/\\*\\*\\//is', '', $content);
            }
        }else{
            if(!$old['target_uri']){
                //  
                $pattern =  '/(.*?)function custom_rewrite_rules\\(\\){(.*?)/is';
                $replacement = '$1function custom_rewrite_rules(){'.$rules.'$2';
                $content = preg_replace($pattern, $replacement, $content);
             }elseif($request_uri != $old['request_uri'] || $target_uri != $old['target_uri']){
                // 
                $pattern = '/\\/\\/start_seo_page-'.$item_id.'(.*?)\\/\\/end_seo_page-'.$item_id.'/is';
                $replacement = $rules;
                $content = preg_replace($pattern, $replacement, $content);
            }
        }
        //  ,   
        if(!$error){
              $bits = file_put_contents(REW_FILE, $content);
              if($bits == 0){ cmsCore::addSessionMessage('      /custom_rewrite.php.       .', 'error'); $error = true;}
        }
        //  ,    
        if(!$error){
           $sql = "UPDATE `cms_seo_page`
                   SET note = '$note',
                       component = '$component',
                       request_uri = '$request_uri',
                       target_uri = '$target_uri',
                       page_title = '$page_title',
                       meta_desc = '$meta_desc',
                       meta_keys = '$meta_keys'
                   WHERE id = $item_id
                   LIMIT 1";
           $inDB->query($sql);
        }
        if($error){$inCore->redirect('?view=components&do=config&opt=edit_item&id='.(int)$_REQUEST['id'].'&item_id='.$item_id);}
    }
    if (!isset($_SESSION['editlist']) || @sizeof($_SESSION['editlist'])==0){
			header('location:?view=components&do=config&id='.(int)$_REQUEST['id'].'&opt=list_items');
		} else {
			header('location:?view=components&do=config&id='.(int)$_REQUEST['id'].'&opt=edit_item');
		}
}

if($opt == 'delete_item'){
		if (!isset($_REQUEST['item'])){
			if (isset($_REQUEST['item_id'])){ $model->deleteSeoPage((int)$_REQUEST['item_id']); }
		} else {
			$model->deleteSeoPages($_REQUEST['item']);
    }
		header('location:?view=components&do=config&id='.(int)$_REQUEST['id'].'&opt=list_items');
}

if ($opt == 'show_item'){
		if (!isset($_REQUEST['item'])){
			if (isset($_REQUEST['item_id'])){
           dbShow('cms_seo_page', (int)$_REQUEST['item_id']);
           activatePageRoute($_REQUEST['item_id']);
      }
			echo '1'; exit;
		} else {
			dbShowList('cms_seo_page', $_REQUEST['item']);
			foreach($_REQUEST['item'] as $item_id){
          activatePageRoute($item_id);
      }
			$opt = 'list_items';
		}
}

if ($opt == 'hide_item'){
		if (!isset($_REQUEST['item'])){
			if (isset($_REQUEST['item_id'])){
          dbHide('cms_seo_page', (int)$_REQUEST['item_id']);
          deActivatePageRoute($_REQUEST['item_id']);
      }
			echo '1'; exit;
		} else {
			dbHideList('cms_seo_page', $_REQUEST['item']);
			foreach($_REQUEST['item'] as $item_id){
          deActivatePageRoute($item_id);
      }
			$opt = 'list_items';
		}
}


if ($opt == 'list_items'){

    //TABLE COLUMNS
		$fields = array();

    $fields[0]['title'] = 'id';			$fields[0]['field'] = 'id';			$fields[0]['width'] = '30';
    
    $fields[1]['title'] = ' URI';		$fields[1]['field'] = 'request_uri';		$fields[1]['width'] = '';
    $fields[1]['link'] = '?view=components&do=config&id='.(int)$_REQUEST['id'].'&opt=edit_item&item_id=%id%';
    $fields[1]['filter'] = 30;
		$fields[1]['maxlen'] = 80;

    $fields[2]['title'] = 'URI ';		$fields[2]['field'] = 'target_uri';		$fields[2]['width'] = '';
    $fields[2]['filter'] = 30;
    $fields[2]['maxlen'] = 80;
		
		$fields[3]['title'] = '';		$fields[3]['field'] = 'component';		$fields[3]['width'] = '';
    $fields[3]['filter'] = 1;  $fields[3]['filterlist'] = $model->cpGetList('cms_components');
    $fields[3]['maxlen'] = 80;

    $fields[4]['title'] = '';		$fields[4]['field'] = 'note';		$fields[4]['width'] = '';
		$fields[4]['maxlen'] = 80;
		
		$fields[5]['title'] = '';		$fields[5]['field'] = 'published';		$fields[5]['width'] = '100';
		$fields[5]['do'] = 'opt';   $fields[5]['do_suffix'] = '_item';
		
		//ACTIONS
		$actions = array();
		$actions[0]['title'] = '  ';
		$actions[0]['icon']  = 'search.gif';
		$actions[0]['link']  = 'http://'.$_SERVER['SERVER_NAME'].'/%request_uri%';
		
		$actions[1]['title'] = '';
		$actions[1]['icon']  = 'edit.gif';
		$actions[1]['link']  = '?view=components&do=config&id='.(int)$_REQUEST['id'].'&opt=edit_item&item_id=%id%';

		$actions[2]['title'] = '';
		$actions[2]['icon']  = 'delete.gif';
		$actions[2]['confirm'] = ' SEO-?';
		$actions[2]['link']  = '?view=components&do=config&id='.(int)$_REQUEST['id'].'&opt=delete_item&item_id=%id%';
		
    //Print table
		cpListTable('cms_seo_page', $fields, $actions, '', 'id DESC');
}

if ($opt == 'add_item' || $opt == 'edit_item'){
    //  
    $messages = cmsCore::getSessionMessages();
                    if ($messages) { ?>
                    <div style="line-height:32px; font-size:18px;">
                        <?php foreach($messages as $message){ ?>
                            <b><?php echo $message; ?></b>
                        <?php } ?>
                    </div>
                    <?php }
    cmsCore::clearSessionMessages();
    if ($opt=='add_item'){
     echo '<h3> SEO-</h3>';
		 cpAddPathway(' SEO-', '?view=components&do=config&id='.(int)$_REQUEST['id'].'&opt=add_item');
		} else {
					 if(isset($_REQUEST['multiple'])){
						if (isset($_REQUEST['item'])){
							$_SESSION['editlist'] = $_REQUEST['item'];
						} else {
							echo '<p class="error">  !</p>';
							return;
						}
					 }

					 $ostatok = '';

					 if (isset($_SESSION['editlist'])){
						$id = array_shift($_SESSION['editlist']);
						if (sizeof($_SESSION['editlist'])==0) { unset($_SESSION['editlist']); } else
						{ $ostatok = '( : '.sizeof($_SESSION['editlist']).')'; }
					 } else { $id = (int)$_REQUEST['item_id']; }

            $mod = array();
						$mod = $model->getSeoPage($id);
            if(!$mod){ header('location:?view=components&do=config&opt=list_items&id='.(int)$_REQUEST['id']); }

					 echo '<h3> SEO-</h3>';
					 cpAddPathway('SEO-', '?view=components&do=config&id='.(int)$_REQUEST['id'].'&opt=list_items');
					 cpAddPathway('SEO--'.$mod['id'], '?view=components&do=config&id='.(int)$_REQUEST['id'].'&opt=edit_item&item_id='.$id);
    }
?>
<form action="index.php?view=components&amp;do=config&amp;id=<?php echo (int)$_REQUEST['id'];?>" method="post" name="addform" id="addform">
  <table width="100%" border="0" cellpadding="0" cellspacing="10" class="proptable">
    <tr>
       <td valign="top" width="350px">
           <strong> URI:</strong><br>
           <span class="hinttext">
           <b><font color="red"> .</font></b>   .<br>
           ,   http://_.ru/catalog/item7.html  catalog/item7.html
           </span>
       </td>
       <td valign="top">
           <input name="request_uri" type="text" size="100" maxlenght="200" value="<?php echo $mod['request_uri']; ?>">
       </td>
    </tr>
    <tr>
       <td valign="top" width="350px">
           <strong>URI :</strong><br>
           <span class="hinttext">
           ,   url http://_.ru/statja.html  statja.html .
             url http://_.ru/kategoria/avtomobili  kategoria/avtomobili .
             ,  url.   ,   url    .
           </span>
       </td>
       <td valign="top">
           <input name="target_uri" type="text" size="100" maxlenght="200" value="<?php echo $mod['target_uri']; ?>">
       </td>
    </tr>
    <tr>
       <td valign="top" width="350px">
           <strong>:</strong><br>
           <span class="hinttext">
           ,       .
           </span>
       </td>
       <td valign="top">
           <textarea name="note" rows="3" style="width:690px"><?php echo $mod['note']; ?></textarea>
       </td>
    </tr>
    <tr>
       <td valign="top" width="350px">
           <strong> :</strong><br>
           <span class="hinttext">
               <b>&#60title&#62&#60/title&#62</b>
           </span>
       </td>
       <td valign="top">
           <input name="page_title" type="text" size="100" maxlenght="200" value="<?php echo $mod['page_title']; ?>">
       </td>
    </tr>
    <tr>
       <td valign="top" width="350px">
           <strong> :</strong><br>
           <span class="hinttext">
            .
           </span>
       </td>
       <td valign="top">
           <textarea name="meta_keys" rows="3" style="width:690px"><?php echo $mod['meta_keys']; ?></textarea>
       </td>
    </tr>
    <tr>
       <td valign="top" width="350px">
           <strong>:</strong><br>
           <span class="hinttext">
            .
           </span>
       </td>
       <td valign="top">
           <textarea name="meta_desc" rows="3" style="width:690px"><?php echo $mod['meta_desc']; ?></textarea>
       </td>
    </tr>
  </table>
  <p>
       <label>
          <input name="add_mod" type="submit" id="add_mod" <?php if ($opt=='add_item') { echo 'value=" SEO-"'; } else { echo 'value=" "'; } ?> />
       </label>
       <label>
          <input name="back2" type="button" id="back2" value="" onclick="window.location.href='index.php?view=components&do=config&id=<?php echo $_REQUEST['id']; ?>';"/>
       </label>
          <input name="opt" type="hidden" id="do" <?php if ($opt=='add_item') { echo 'value="submit_item"'; } else { echo 'value="update_item"'; } ?> />
          <?php
		  	    if ($opt=='edit_item'){
				      echo '<input name="item_id" type="hidden" value="'.$mod['id'].'" />';
			      }
		      ?>
        </p>
</form>
<div>
<p><b><font color="red">.</font></b>   " URI".      .  -  
,       ,    .<br>
<b><font color="red">.</font></b> ,    "URI "     URI.    .<br>
        /custom_rewrite.php    .    .  
      .</p>
</div>
<?php
}

?>
