<?php

// ========================================================================== //

    function info_component_seo_page(){

        // 

        $_component['title']        = 'SEO-';                        //
        $_component['description']  = '  seo-    .';    //
        $_component['link']         = 'seo_page';                               // ()
        $_component['author']       = 'Marat Fatikhov';                        //
        $_component['internal']     = '0';                                  // (  )? 1-, 0-
        $_component['version']      = '1.1.1';                                // 

        // -

        $_component['config'] = array();

        return $_component;

    }

// ========================================================================== //

    function install_component_seo_page(){

        $inCore     = cmsCore::getInstance();       // 
        $inDB       = cmsDatabase::getInstance();   //  
        $inConf     = cmsConfig::getInstance();

        include($_SERVER['DOCUMENT_ROOT'].'/includes/dbimport.inc.php');

        dbRunSQL($_SERVER['DOCUMENT_ROOT'].'/components/seo_page/install.sql', $inConf->db_prefix);

        return true;

    }
    
    // ========================================================================== //

    function upgrade_component_seo_page(){

        $inCore     = cmsCore::getInstance();
        $inDB       = cmsDatabase::getInstance();
        
        $inDB->query('ALTER TABLE `cms_seo_page` DROP INDEX `request`');
        $inDB->query('ALTER TABLE `cms_seo_page` DROP INDEX `target`');
        $inDB->query('ALTER TABLE `cms_seo_page` ADD INDEX `request` ( `request_uri` )');
        $inDB->query('ALTER TABLE `cms_seo_page` ADD INDEX `target` ( `target_uri` )');

        return true;

    }

// ========================================================================== //

?>
