<?php
/*******************************************************************************/
//                          InstantCMS v1.9                                    //
//                      http://www.instantcms.ru/                              //
//                         plugin p_seo_page v1.0                              //
//                     written by Marat Fatikhov  aka                     //
//                     http://www.instantcms.ru/users/marat                    //
//                       E-mail: f-marat@mail.ru                               //
//                                                                             //
//                      LICENSED BY GNU/GPL v2                                 //
//                                                                             //
/********************************************************************************/

class p_seo_page extends cmsPlugin {

// ==================================================================== //

    public function __construct(){

        parent::__construct();

        //   

        $this->info['plugin']           = 'p_seo_page';
        $this->info['title']            = 'SEO ';
        $this->info['description']      = ' SEO      ';
        $this->info['author']           = 'Marat Fatikhov';
        $this->info['version']          = '1.0';

        //  -
        $this->config[' , 1 - ,  - ']   = '';

        // ,    
        $inCore = cmsCore::getInstance();
        $components = array();
        $components = $inCore->getComponentsDirs();
        
        foreach($components as $component){
          $this->events[]                 = 'AFTER_COMPONENT_'.mb_strtoupper($component);
        }
    }

// ==================================================================== //

    /**
     *   
     * @return bool
     */
    public function install(){

        return parent::install();

    }

// ==================================================================== //

    /**
     *   
     * @return bool
     */
    public function upgrade(){

        return parent::upgrade();

    }

// ==================================================================== //

    /**
     *  
     * @param string $event
     * @param mixed $item
     * @return mixed
     */
    public function execute($event, $item){

        parent::execute();

            $item = $this->sendSeo($item);

        return $item;
    }

// ==================================================================== //

    private function sendSeo($item){

        $inCore = cmsCore::getInstance();
        $inDB   = cmsDatabase::getInstance();
        $inUser = cmsUser::getInstance();
        $inPage = cmsPage::getInstance();
        
        $uri    = $_SERVER['REQUEST_URI'];
        $uri = trim($uri, '/');
        if(!$uri){ return $item; }
        
        $sql = "SELECT *
                FROM `cms_seo_page`
                WHERE published = 1 AND (request_uri = '{$uri}' OR target_uri = '{$uri}')
                LIMIT 1";
                
        $res = $inDB->query($sql);
        if($inDB->num_rows($res)){
           $params = array();
           $params = $inDB->fetch_assoc($res);
           if($params['page_title']){ $inPage->setTitle($params['page_title']); }
           if($params['meta_desc']){ $inPage->setDescription($params['meta_desc']); }
           if($params['meta_keys']){ $inPage->setKeywords($params['meta_keys']); }
        }
        
        if($inUser->is_admin){
            $is_link = $this->config[' , 1 - ,  - '];
            $comp_id = $inCore->getComponentId('seo_page');
            if($is_link && $comp_id){
            
                 if($params){
                   $item .= '<div id="wind">
                               <a href="http://'.$_SERVER['SERVER_NAME'].'/admin/index.php?view=components
                               &do=config&id='.$comp_id.'&opt=edit_item&item_id='.$params['id'].'" target="_blank">
                                SEO-
                               </a>
                             </div>
                             ';
                           
                }else{
                   $item .= '<div id="wind">
                                <a href="http://'.$_SERVER['SERVER_NAME'].'/admin/index.php?view=components&do=config&id='.$comp_id.'&opt=add_item" target="_blank">
                                 SEO-
                                </a>
                             </div>';
                }
                
                $item .= '
                         <style>
                                 #wind {
                                         position: absolute;
                                         width:320px;
                                         left: 35%;
                                         top: 0;
                                         left: 0;
                                         border:solid #105a98 4px;
                                         z-index: 1000;
                                         overflow: hidden;
                                         background-color:#00ffc3;
                                         color:#fff;
                                         text-align:center;
                                         padding:10px;
                                }
                             </style>
                         ';
                
            }
        }
        
        return $item;
    }

//==============================================================================//


} //class
?>
